## vala-panel-appmenu 0.5.3

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
cmake_policy (VERSION 2.8)
project (vala-panel-appmenu C)
enable_testing ()
include(GNUInstallDirs)
set (DATADIR "${CMAKE_INSTALL_FULL_DATADIR}/vala-panel")
set (PKGDATADIR "${DATADIR}")
set (GETTEXT_PACKAGE "vala-panel-appmenu")
set (RELEASE_NAME "Vala Panel Application Menu")
set (PREFIX ${CMAKE_INSTALL_PREFIX})
set (DOLLAR "$")
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(GitVersion)
determine_fallback_version(${CMAKE_SOURCE_DIR}/cmake)
include(FallbackVersion)
include(Format)

# Add 'make dist' command for creating release tarball
set (CPACK_PACKAGE_VERSION ${VERSION})
set (CPACK_PACKAGE_RELEASE "1")
set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_SOURCE_IGNORE_FILES "/build/;/.gitmodules;/.git;/.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

include (CPack)
add_custom_target (dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
#Add RPM build support
include (UseRPMTools)
if (RPMTools_FOUND)
   RPMTools_ADD_RPM_TARGETS(appmenu ${CMAKE_SOURCE_DIR}/rpm/vala-panel-appmenu.spec.in)
   RPMTools_ADD_RPM_TARGETS(module ${CMAKE_SOURCE_DIR}/rpm/appmenu-gtk-module.spec.in)
   RPMTools_ADD_RPM_TARGETS(jayatana ${CMAKE_SOURCE_DIR}/rpm/java-appmenu.spec.in)
endif(RPMTools_FOUND)

# Configuration
configure_file (${CMAKE_SOURCE_DIR}/vapi/config.vala.in ${CMAKE_BINARY_DIR}/vapi/config.vala)

# Some definitions
add_definitions(-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\")

# Vala
find_package (Vala REQUIRED)
include (ValaVersion)
ensure_vala_version ("0.24" MINIMUM)
include (ValaPrecompile)

add_definitions(-DVALA_VERSION="${VALA_SHORTVER}")
#add_definitions(-w) #Suppress all GCC warnings
add_definitions(-Wall -Wno-unused # Vala loves to create variables
                -Wno-unused-parameter
#		-pedantic
                -Wno-ignored-qualifiers
                -Wno-incompatible-pointer-types
                -Wno-missing-field-initializers
                -Wno-discarded-qualifiers
                -Wno-sign-compare
                -Wextra) #Vala often forgot cast to GtkWidget or gpointer

find_package (PkgConfig)

pkg_check_modules (CORE QUIET
  gtk+-3.0>=3.10
  glib-2.0>=2.44
  gio-2.0>=2.44
  gio-unix-2.0>=2.44
  gthread-2.0>=2.44
  gmodule-2.0>=2.44
  libbamf3)

pkg_check_modules(GTK3 REQUIRED
    gtk+-3.0>=3.10)

pkg_check_modules(GLIB REQUIRED
    glib-2.0>=2.44
    gio-2.0>=2.44
    gio-unix-2.0>=2.44
    gthread-2.0>=2.44
    gmodule-2.0>=2.44)

pkg_check_modules(BAMF REQUIRED
    libbamf3)

set(CORE_PACKAGES
  gtk+-3.0
  glib-2.0
  gio-2.0
  gio-unix-2.0
  gmodule-2.0
  libbamf3
  posix)

#set requred variables
set(TARGET_GLIB ${GLIB_VERSION_MAJOR}.${GLIB_VERSION_MINOR})
include(CMakeDependentOption)

#set build options
pkg_check_modules(WNCK libwnck-3.0>=3.4.0)
cmake_dependent_option(ENABLE_WNCK "Enable libwnck-related functions" ON
    "WNCK_FOUND" OFF)
if (ENABLE_WNCK)
    message("Using libwnck, will be X-dependent")
    set(WNCK_DEFINE -D WNCK)
    set(WNCK_PACKAGES libwnck-3.0)
endif()
pkg_check_modules(XFCE libxfce4panel-2.0 libxfconf-0)
cmake_dependent_option(ENABLE_XFCE "Enable Xfce Panel Integration" ON
    "XFCE_FOUND" OFF)

pkg_check_modules(MATE libmatepanelapplet-4.0)
cmake_dependent_option(ENABLE_MATE "Enable mate-panel Integration" ON
    "MATE_FOUND" OFF)

pkg_check_modules(PEAS libpeas-1.0)
pkg_check_modules(VALAPANEL vala-panel)
pkg_check_modules(VP_NEW vala-panel>=0.3.50 QUIET)
pkg_check_modules(BUDGIE budgie-1.0 libpeas-1.0)

cmake_dependent_option(ENABLE_VALAPANEL "Enable Vala Panel Integration" ON
    "VALAPANEL_FOUND; PEAS_FOUND" OFF)
if (VP_NEW_FOUND)
    message("Using 0.4 ValaPanelApplet api")
    set(NEW_DEFINE -D NEW)
    set(NEW_IFACE ON)
endif()

cmake_dependent_option(ENABLE_BUDGIE "Enable budgie-desktop plugin" ON
    "BUDGIE_FOUND; PEAS_FOUND" OFF)

option(MAKE_BOLD_APPNAME "Make application name bold, if you like it" OFF)
if(MAKE_BOLD_APPNAME)
    set(BOLD_DEFINE -D BOLD)
endif()
add_subdirectory(unity-gtk-module)
ADD_SUBDIRECTORY(jayatana)
add_subdirectory(dbusmenu)
ADD_SUBDIRECTORY(lib)
add_subdirectory(data)
add_subdirectory(po)

=== data/CMakeLists.txt ===
if (ENABLE_XFCE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/xfce4/panel/plugins)
endif()
if (ENABLE_MATE)
    configure_file(${CMAKE_SOURCE_DIR}/data/appmenu-mate.desktop.plugin.in ${CMAKE_SOURCE_DIR}/data/appmenu-mate.desktop.in)
    configure_file(${CMAKE_SOURCE_DIR}/data/appmenu-mate.service.in ${CMAKE_BINARY_DIR}/data/appmenu-mate.serivce)
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-mate.serivce DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/dbus-1/services/ RENAME org.mate.panel.applet.AppmenuAppletFactory.service)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-mate.desktop DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/mate-panel/applets/ RENAME org.vala-panel.appmenu.mate-panel-applet)
endif()
if (ENABLE_VALAPANEL)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu.plugin DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/vala-panel/applets/)
endif()
if (ENABLE_BUDGIE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-budgie.plugin DESTINATION ${CMAKE_INSTALL_LIBDIR}/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin)
endif()

=== jayatana/CMakeLists.txt ===
include(CMakeDependentOption)
find_package(Java)
find_package(JNI)
pkg_check_modules(XKBCOMMON
    xkbcommon)
pkg_check_modules(DBUSMENU
    dbusmenu-glib-0.4)
cmake_dependent_option(ENABLE_JAYATANA "Build jayatana fork" OFF
    "JAVA_FOUND;JNI_FOUND;XKBCOMMON_FOUND;DBUSMENU_FOUND" OFF)
if (ENABLE_JAYATANA)
    add_subdirectory(lib)
    add_subdirectory(java)
endif()

=== lib/CMakeLists.txt ===
#####
# Core Parts (GResource, definitions)
#####
add_definitions(-fPIC)
add_definitions(-DWNCK_I_KNOW_THIS_IS_UNSTABLE)
set(CORE_VALA_FILES
    appmenu-bamf.vala
    appmenu-desktop.vala
    registrar.vala
    menubar.vala
    menu-widget.vala
    menu-widget-dbusmenu.vala
    menu-widget-menumodel.vala
    ${CMAKE_BINARY_DIR}/vapi/config.vala
)
vala_precompile(VALA_C_CORE appmenu-core
    ${CORE_VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    vala-dbusmenu
    gio-addons-2.0
    launcher
    ${WNCK_PACKAGES}
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_CURRENT_BINARY_DIR}
    --vapidir=${CMAKE_BINARY_DIR}/dbusmenu
    --target-glib=2.44
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
    --thread
    ${WNCK_DEFINE}
    ${BOLD_DEFINE}
GENERATE_VAPI
    vala-panel-appmenu
)
INCLUDE(GResource)
glib_compile_resources(RESOURCES
    source
        libappmenu.gresource.xml
)
include_directories(${CMAKE_SOURCE_DIR})
set(CORE_C_FILES launcher.c launcher.h)
set(PLUGIN_VALA_FILES
    valapanel-plugin-appmenu.vala
    xfce4-plugin-appmenu.vala
    mate-plugin-appmenu.vala
    budgie-plugin-appmenu.vala
    )
add_library(appmenu-core STATIC ${CORE_C_FILES} ${VALA_C_CORE} $<TARGET_OBJECTS:vala-dbusmenu-o>)
target_link_libraries (appmenu-core ${CORE_LIBRARIES} ${WNCK_LIBRARIES} m)
target_include_directories (appmenu-core PRIVATE ${CORE_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR}/dbusmenu)
add_custom_target(vala-files-ide SOURCES ${VALA_FILES_DBUSMENU} ${CORE_VALA_FILES} ${PLUGIN_VALA_FILES})
##########
# XFCE Part
##########
if (ENABLE_XFCE)
    vala_precompile(VALA_C_XFCE appmenu-xfce
        xfce4-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        libxfce4panel-2.0
        libxfconf-0
    OPTIONS
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
	--target-glib=2.44
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        --thread
        ${WNCK_DEFINE}
    )
    set (XF_CFLAGS ${CORE_CFLAGS} ${WNCK_CFLAGS} ${XFCE_CFLAGS})
    add_definitions(${XF_CFLAGS})
    add_library (appmenu-xfce MODULE
        ${VALA_C_XFCE}
        ${RESOURCES}
    )
    target_link_libraries (appmenu-xfce ${CORE_LIBRARIES} ${WNCK_LIBRARIES} ${XFCE_LIBRARIES} m appmenu-core)
    target_include_directories (appmenu-xfce PRIVATE ${CORE_INCLUDE_DIRS} ${WNCK_INCLUDE_DIRS} ${XFCE_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
    link_directories (${CORE_LIBRARY_DIRS} ${WNCK_LIBRARY_DIRS} ${XFCE_LIBRARY_DIRS})
    add_dependencies(appmenu-xfce appmenu-core)
    # Install plugin stuffs
    install(TARGETS appmenu-xfce DESTINATION ${CMAKE_INSTALL_LIBDIR}/xfce4/panel/plugins)
endif()
##########
# ValaPanel Part
##########
if(ENABLE_VALAPANEL)
    vala_precompile(VALA_C_VALAPANEL appmenu-valapanel
        valapanel-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        vala-panel
        libpeas-1.0
        vala-dbusmenu
    OPTIONS
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --vapidir=${CMAKE_BINARY_DIR}/dbusmenu
	--target-glib=2.44
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        --thread
        ${WNCK_DEFINE}
        ${NEW_DEFINE}
    )

    # Build library for plugins and application
    set (VP_CFLAGS ${CORE_CFLAGS} ${WNCK_CFLAGS} ${VALAPANEL_CFLAGS})
    add_definitions(${VP_CFLAGS})
    add_library (appmenu-valapanel MODULE
        ${VALA_C_VALAPANEL}
        ${RESOURCES}
    )
    target_include_directories (appmenu-valapanel PRIVATE ${CORE_INCLUDE_DIRS} ${WNCK_INCLUDE_DIRS} ${VALAPANEL_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries (appmenu-valapanel ${CORE_LIBRARIES} ${WNCK_LIBRARIES} ${VALAPANEL_LIBRARIES} m appmenu-core)
    link_directories (${CORE_LIBRARY_DIRS} ${WNCK_LIBRARY_DIRS} ${VALAPANEL_LIBRARY_DIRS})
    # Install plugin stuffs
    install(TARGETS appmenu-valapanel DESTINATION ${CMAKE_INSTALL_LIBDIR}/vala-panel/applets)
endif()
##########
# Budgie Panel Part
##########
if(ENABLE_BUDGIE)
    vala_precompile(VALA_C_BUDGIE appmenu-budgie
        budgie-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        budgie-1.0
        libpeas-1.0
    OPTIONS
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.44
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        --thread
        ${WNCK_DEFINE}
    )

    # Build library for plugins and application
    set (VP_CFLAGS ${CORE_CFLAGS} ${WNCK_CFLAGS} ${BUDGIE_CFLAGS})
    add_definitions(${VP_CFLAGS})
    add_library (appmenu-budgie MODULE
        ${VALA_C_BUDGIE}
        ${RESOURCES}
    )
    add_dependencies(appmenu-budgie appmenu-core)
    target_include_directories (appmenu-budgie PRIVATE ${CORE_INCLUDE_DIRS} ${WNCK_INCLUDE_DIRS} ${BUDGIE_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries (appmenu-budgie ${CORE_LIBRARIES} ${WNCK_LIBRARIES} ${BUDGIE_LIBRARIES} m appmenu-core)
    link_directories (${CORE_LIBRARY_DIRS} ${WNCK_LIBRARY_DIRS} ${BUDGIE_LIBRARY_DIRS})
    # Install plugin stuffs
    install(TARGETS appmenu-budgie DESTINATION ${CMAKE_INSTALL_LIBDIR}/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin)
endif()
##########
# MATE Part
##########
if (ENABLE_MATE)
    vala_precompile(VALA_C_MATE appmenu-mate
	mate-plugin-appmenu.vala
    PACKAGES
	${CORE_PACKAGES}
	vala-panel-appmenu
	${WNCK_PACKAGES}
	libmatepanelapplet-4.0
    OPTIONS
	--vapidir=${CMAKE_SOURCE_DIR}/vapi
	--vapidir=${CMAKE_CURRENT_BINARY_DIR}
	--target-glib=2.44
	--gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
	--thread
	${WNCK_DEFINE}
    )
    set (MA_CFLAGS ${CORE_CFLAGS} ${WNCK_CFLAGS} ${MATE_CFLAGS})
    add_definitions(${MA_CFLAGS})
    add_executable (appmenu-mate
        ${VALA_C_MATE}
	${RESOURCES}
    )
    target_link_libraries (appmenu-mate ${CORE_LIBRARIES} ${WNCK_LIBRARIES} ${MATE_LIBRARIES} m appmenu-core)
    target_include_directories (appmenu-mate PRIVATE ${CORE_INCLUDE_DIRS} ${WNCK_INCLUDE_DIRS} ${MATE_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
    link_directories (${CORE_LIBRARY_DIRS} ${WNCK_LIBRARY_DIRS} ${MATE_LIBRARY_DIRS})
    add_dependencies(appmenu-mate appmenu-core)
    # Install plugin stuffs
    install(TARGETS appmenu-mate DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/mate-panel)
endif()

=== po/CMakeLists.txt ===
include(Translations)
add_translations_directory("vala-panel-appmenu")
add_translations_catalog("vala-panel-appmenu"
    ../lib
    ../data/xfce
)

=== unity-gtk-module/CMakeLists.txt ===
pkg_check_modules(GTK2
	gtk+-2.0>=2.24)
find_package(X11)

cmake_dependent_option(ENABLE_UNITY_GTK_MODULE "Build unity-gtk-module" OFF
	"X11_FOUND" OFF)
cmake_dependent_option(ENABLE_GTK_MODULE_DEMOS "Enable demo programs for gtk module" OFF
	"ENABLE_UNITY_GTK_MODULE" OFF)


if(ENABLE_UNITY_GTK_MODULE)
pkg_check_modules(DOC gtk-doc>=1.26)
	if(DOC_FOUND)
		add_subdirectory(docs)
	endif()
	add_subdirectory(data)
	add_subdirectory(lib)
	add_subdirectory(src)
	add_subdirectory(tests)
endif()

=== jayatana/java/CMakeLists.txt ===
include(UseJava)
configure_file(core/basic/NativeLibraries.java.in ${CMAKE_CURRENT_BINARY_DIR}/core/basic/NativeLibraries.java)
set(JAVA_SOURCES
    core/Feature.java
    core/FeatureManager.java
    core/FeatureWrapper.java
    core/basic/GMainLoop.java
    core/basic/GlobalMenuAdapter.java
    core/basic/GlobalMenu.java
    ${CMAKE_CURRENT_BINARY_DIR}/core/basic/NativeLibraries.java
    core/swing/SwingGlobalMenu.java
    core/swing/SwingGTKFixed.java
    core/swing/SwingWMClass.java
    core/swing/SwingGlobalMenuWindow.java
    agent/Agent.java
    )
add_jar(jayatana-java
    SOURCES
        core/Feature.java
        core/FeatureManager.java
        core/FeatureWrapper.java
        core/basic/GMainLoop.java
        core/basic/GlobalMenuAdapter.java
        core/basic/GlobalMenu.java
        ${CMAKE_CURRENT_BINARY_DIR}/core/basic/NativeLibraries.java
        core/swing/SwingGlobalMenu.java
        core/swing/SwingGTKFixed.java
        core/swing/SwingWMClass.java
        core/swing/SwingGlobalMenuWindow.java
    OUTPUT_NAME
        jayatana
    )
create_javah(TARGET java-headers
    CLASSES
        com.jarego.jayatana.basic.GMainLoop
        com.jarego.jayatana.basic.GlobalMenu      
    CLASSPATH
        jayatana-java
    )
install_jar(jayatana-java DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/java)
configure_file(agent/MANIFEST.MF.in ${CMAKE_CURRENT_BINARY_DIR}/agent/MANIFEST.MF)
add_jar(agent-java
    SOURCES
        agent/Agent.java
    OUTPUT_NAME
        jayatanaag
    MANIFEST
        ${CMAKE_CURRENT_BINARY_DIR}/agent/MANIFEST.MF
    )
install_jar(agent-java DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/java)
add_custom_target(java-files-ide SOURCES ${JAVA_SOURCES})

=== jayatana/lib/CMakeLists.txt ===
configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
add_library(jayatanaag SHARED
    com_jarego_jayatana_Agent.h
    com_jarego_jayatana_Agent.c)
target_include_directories(jayatanaag PRIVATE ${JNI_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(jayatanaag PRIVATE ${JNI_LIBRARIES})
pkg_check_modules(LINK REQUIRED QUIET
    glib-2.0
    gio-2.0
    xkbcommon)
pkg_check_modules(TEMP REQUIRED QUIET
    dbusmenu-glib-0.4)
include(UseJava)
add_library(jayatana SHARED
    com_jarego_jayatana_basic_GlobalMenu.c
    com_jarego_jayatana_basic_GMainLoop.c
    com_jarego_jayatana_collections.c
    com_jarego_jayatana_collections.h
    com_jarego_jayatana_jkey2xkey.c
    com_jarego_jayatana_jkey2xkey.h
    com_jarego_jayatana_jni.c
    com_jarego_jayatana_jni.h)
add_dependencies(jayatana java-headers)
target_include_directories(jayatana  PRIVATE ${JNI_INCLUDE_DIRS} ${LINK_INCLUDE_DIRS} ${TEMP_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR}/../java)
target_link_libraries(jayatana  PRIVATE ${JNI_LIBRARIES} ${LINK_LIBRARIES} ${TEMP_LIBRARIES})

install(TARGETS jayatana jayatanaag DESTINATION ${CMAKE_INSTALL_LIBDIR}/jayatana)

=== unity-gtk-module/data/CMakeLists.txt ===
add_custom_target(data-files-module SOURCES org.valapanel.appmenu-gtk-module.gschema.xml appmenu-gtk-module.service)


include(GSettings)
add_schema("org.valapanel.appmenu-gtk-module.gschema.xml" "bin")
pkg_check_modules(SYSTEMD "systemd")
if (SYSTEMD_FOUND AND "${SYSTEMD_SERVICES_INSTALL_DIR}" STREQUAL "")
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE}
        --variable=systemduserunitdir systemd
       OUTPUT_VARIABLE SYSTEMD_SERVICES_INSTALL_DIR)
    string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SERVICES_INSTALL_DIR
        "${SYSTEMD_SERVICES_INSTALL_DIR}")
elseif (NOT SYSTEMD_FOUND AND SYSTEMD_SERVICES_INSTALL_DIR)
    message (FATAL_ERROR "Variable SYSTEMD_SERVICES_INSTALL_DIR is\
        defined, but we can't find systemd using pkg-config")
endif()
configure_file(appmenu-gtk2-parser.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appmenu-gtk2-parser.pc)
configure_file(appmenu-gtk3-parser.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appmenu-gtk3-parser.pc)
configure_file(appmenu-gtk-module.service.in ${CMAKE_CURRENT_BINARY_DIR}/appmenu-gtk-module.service)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-gtk3-parser.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
if(GTK2_FOUND)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-gtk2-parser.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()
if (SYSTEMD_FOUND)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appmenu-gtk-module.service DESTINATION ${SYSTEMD_SERVICES_INSTALL_DIR})
endif()

=== unity-gtk-module/docs/CMakeLists.txt ===
find_package(GtkDoc 1.25)

SET(IGNORE_LIST
	unity-gtk-menu-shell-private.h
	unity-gtk-menu-section-private.h
	unity-gtk-menu-item-private.h
	unity-gtk-action-group-private.h
	unity-gtk-action-private.h)

if (GTKDOC_FOUND)
    gtk_doc_add_module(
       appmenu-gtk-module ${CMAKE_SOURCE_DIR}/unity-gtk-module/docs
          LIBRARIES unity-gtk3-module
          SOURCE ${CMAKE_SOURCE_DIR}/lib
          IGNOREHEADERS ${IGNORE_LIST}
    )
endif()

=== unity-gtk-module/lib/CMakeLists.txt ===
set(LIB_SOURCES
	unity-gtk-action-group.h
	unity-gtk-action-group-private.h
	unity-gtk-action-group.c
	unity-gtk-action-private.h
	unity-gtk-action.c
	unity-gtk-menu-shell.h
	unity-gtk-menu-shell-private.h
	unity-gtk-menu-shell.c
	unity-gtk-menu-section-private.h
	unity-gtk-menu-section.c
	unity-gtk-menu-item-private.h
	unity-gtk-menu-item.c
)
set(GTK3_SOURCES
    )

add_library(appmenu-gtk3-parser SHARED
        ${LIB_SOURCES}
        ${GTK3_SOURCES})

target_include_directories(appmenu-gtk3-parser PRIVATE ${GLIB_INCLUDE_DIRS} ${GTK3_INCLUDE_DIRS} ${X11_INCLUDE_DIRS})
target_link_libraries(appmenu-gtk3-parser PRIVATE ${GLIB_LIBRARIES} ${GTK3_LIBRARIES} ${X11_LIBRARIES})
set_target_properties(appmenu-gtk3-parser PROPERTIES
	VERSION ${VERSION}
	SOVERSION ${VERSION_MAJOR})
install(TARGETS appmenu-gtk3-parser DESTINATION ${CMAKE_INSTALL_LIBDIR})

if (GTK2_FOUND)
	add_library(appmenu-gtk2-parser SHARED
		${LIB_SOURCES})
	set_target_properties(appmenu-gtk2-parser PROPERTIES
		VERSION ${VERSION}
		SOVERSION ${VERSION_MAJOR})
	target_include_directories(appmenu-gtk2-parser PRIVATE ${GLIB_INCLUDE_DIRS} ${GTK2_INCLUDE_DIRS} ${X11_INCLUDE_DIRS})
	target_link_libraries(appmenu-gtk2-parser PRIVATE ${GLIB_LIBRARIES} ${GTK2_LIBRARIES} ${X11_LIBRARIES})
	install(TARGETS appmenu-gtk2-parser DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

set(LIB_PUBLIC_HEADERS
	unity-gtk-parser.h
	unity-gtk-menu-shell.h
	unity-gtk-action-group.h)

set(GTK_MODULE_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR}/appmenu-gtk-module)

install(FILES ${LIB_PUBLIC_HEADERS} DESTINATION ${GTK_MODULE_INCLUDE_DIR})

=== unity-gtk-module/src/CMakeLists.txt ===
set(MODULE_SOURCES main.c
    platform.c
    platform.h
    )

set(GTK3_MODULEDIR ${GTK3_LIBDIR}/gtk-3.0/modules)
add_library(appmenu-gtk3-module MODULE ${MODULE_SOURCES})
target_include_directories(appmenu-gtk3-module PRIVATE ${GLIB_INCLUDE_DIRS} ${GTK3_INCLUDE_DIRS} ${X11_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/../lib)
target_link_libraries(appmenu-gtk3-module PRIVATE ${GLIB_LIBRARIES} ${GTK3_LIBRARIES} ${X11_LIBRARIES} appmenu-gtk3-parser)
set_target_properties(appmenu-gtk3-module PROPERTIES
    OUTPUT_NAME appmenu-gtk-module
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gtk-3.0)
install(TARGETS appmenu-gtk3-module DESTINATION ${GTK3_MODULEDIR})

if(GTK2_FOUND)
    set(GTK2_MODULEDIR ${GTK2_LIBDIR}/gtk-2.0/modules)
    add_library(appmenu-gtk2-module MODULE ${MODULE_SOURCES})
    target_include_directories(appmenu-gtk2-module PRIVATE ${GLIB_INCLUDE_DIRS} ${GTK2_INCLUDE_DIRS} ${X11_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/../lib)
    target_link_libraries(appmenu-gtk2-module PRIVATE ${GLIB_LIBRARIES} ${GTK2_LIBRARIES} ${X11_LIBRARIES} appmenu-gtk2-parser)
    set_target_properties(appmenu-gtk2-module PROPERTIES
        OUTPUT_NAME appmenu-gtk-module
        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gtk-2.0)
    install(TARGETS appmenu-gtk2-module DESTINATION ${GTK2_MODULEDIR})
endif()

=== debian/changelog ===
vala-panel-appmenu (0.5.3-0ubuntu2) artful; urgency=medium

  * Add gschema overrides to add the appropriate unity-gtk-module
    blacklist for Budgie and MATE. (LP: #1705653)

 -- Martin Wimpress <martin.wimpress@ubuntu.com>  Wed, 30 Aug 2017 11:08:34 +0100

vala-panel-appmenu (0.5.3-0ubuntu1) artful; urgency=medium

  * New upstream release.

 -- Martin Wimpress <code@flexion.org>  Mon, 14 Aug 2017 23:03:02 +0100

vala-panel-appmenu (0.5.2-0ubuntu1) artful; urgency=medium

  * Initial upload. (LP: #1699334)

 -- Martin Wimpress <martin.wimpress@ubuntu.com>  Sat, 15 Jul 2017 23:32:12 +0100

=== debian/control ===
Source: vala-panel-appmenu
Section: x11
Priority: optional
Maintainer: Martin Wimpress <martin.wimpress@ubuntu.com>
Build-Depends: budgie-core-dev,
               cmake (>= 2.8.0),
               debhelper (>= 10),
               libbamf3-dev,
               libgtk-3-dev (>= 3.12.0),
               libmate-panel-applet-dev (>= 1.16),
               libpeas-dev (>= 1.2.0),
               libvalapanel-dev (>= 0.3.60),
               libwnck-3-dev (>= 3.4.0),
               libxfce4panel-2.0-dev,
               libxfconf-0-dev,
               valac (>= 0.24.0),
               xfce4-panel-dev (>= 4.11.2),
Standards-Version: 4.0.0
Homepage: https://github.com/rilian-la-te/vala-panel-appmenu
Vcs-Git: https://github.com/rilian-la-te/vala-project-packages.git
Vcs-Browser: https://github.com/rilian-la-te/vala-project-packages

Package: budgie-appmenu-applet
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt,
            appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            unity-gtk2-module,
            unity-gtk3-module,
Description: Application Menu plugin for budgie-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides the plugin for Budgie.

Package: xfce4-appmenu-plugin
Section: xfce
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt,
            appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            unity-gtk2-module,
            unity-gtk3-module,
Description: Application Menu plugin for xfce4-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides the plugin for Xfce.

Package: mate-applet-appmenu
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt,
            appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            unity-gtk2-module,
            unity-gtk3-module,
Description: Application Menu plugin for mate-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides the plugin for MATE.

Package: vala-panel-appmenu
Architecture: any
Depends: bamfdaemon,
         vala-panel-appmenu-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: appmenu-qt,
            appmenu-qt5,
            libdbusmenu-glib4,
            libdbusmenu-gtk3-4,
            libdbusmenu-gtk4,
            unity-gtk2-module,
            unity-gtk3-module,
Description: Application Menu plugin for vala-panel
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.

Package: vala-panel-appmenu-common
Architecture: all
Depends: ${misc:Depends},
Description: Common files for Application Menu plugins
 This is an Application Menu (Global Menu) plugin. It is built using
 the Unity protocol and libraries and provides all features found in
 the Unity implementation.
 .
 This package provides common files.

=== debian/rules ===
#!/usr/bin/make -f

DHFLAGS=--buildsystem=cmake
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ $(DHFLAGS)

override_dh_auto_build:
	dh_auto_build $(DHFLAGS)

override_dh_install:
	dh_install --list-missing

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DENABLE_BUDGIE=ON \
		-DENABLE_MATE=ON \
		-DENABLE_VALAPANEL=ON \
		-DENABLE_XFCE=ON \
		-DMAKE_BOLD_APPNAME=ON \
		-DCMAKE_INSTALL_LIBEXECDIR=/usr/lib

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/budgie-desktop/plugins/appmenu-budgie
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin/* $(CURDIR)/debian/tmp/usr/lib/budgie-desktop/plugins/appmenu-budgie

override_dh_makeshlibs:
	dh_makeshlibs -Xbudgie -Xmate -Xvala-panel -Xxfce4

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://github.com/rilian-la-te/vala-panel-appmenu/releases .*/vala-panel-appmenu-(\d\S+)\.tar\.gz

## vala-panel-appmenu 0.6.94%2Brepack1

=== lib/CMakeLists.txt ===
#####
# Core Parts (GResource, definitions)
#####
set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_subdirectory(dbusmenu-importer)
set(CORE_VALA_FILES
    appmenu-abstractions.vala
    appmenu-bamf.vala
    registrar.vala
    menu-widget.vala
    helper-desktop.vala
    helper-dbus.vala
    helper-dbusmenu.vala
    helper-menumodel.vala
    ${CMAKE_BINARY_DIR}/vapi/config.vala
)
vala_precompile(VALA_C_CORE appmenu-core
    ${CORE_VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    dbus-menu-importer
    gio-addons-2.0
    launcher
    ${WNCK_PACKAGES}
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_CURRENT_BINARY_DIR}
    --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/dbusmenu-importer
    --target-glib=2.50
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
    --thread
    ${WNCK_DEFINE}
GENERATE_VAPI
    vala-panel-appmenu
)
glib_compile_resources(RESOURCES
    source
        libappmenu.gresource.xml
)
include_directories(${CMAKE_SOURCE_DIR})
set(CORE_C_FILES
    launcher.c
    launcher.h
)
set(PLUGIN_VALA_FILES
    valapanel-plugin-appmenu.vala
    xfce4-plugin-appmenu.vala
    mate-plugin-appmenu.vala
    budgie-plugin-appmenu.vala
    )
add_library(appmenu-core STATIC ${CORE_C_FILES} ${VALA_C_CORE})
target_link_libraries (appmenu-core
    dbusmenu-importer
    GLIB2::GIO_UNIX
    GLIB2::GOBJECT
    GTK3::GTK
    GTK3::GDK
    BAMF::LIB
    ${WNCK_TARGETS}
    m)
set_target_properties(appmenu-core PROPERTIES
        POSITION_INDEPENDENT_CODE ON	# Compile this object code position independent.
)
add_custom_target(vala-files-ide SOURCES ${VALA_FILES_DBUSMENU} ${CORE_VALA_FILES} ${PLUGIN_VALA_FILES})
##########
# XFCE Part
##########
if (ENABLE_XFCE)
    vala_precompile(VALA_C_XFCE appmenu-xfce
        xfce4-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        libxfce4panel-2.0
        libxfconf-0
    OPTIONS
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        --thread
        ${WNCK_DEFINE}
    )
    add_library (appmenu-xfce MODULE
        ${VALA_C_XFCE}
        ${RESOURCES}
    )
    target_link_libraries (appmenu-xfce appmenu-core PkgConfig::XFCE)
    # Install plugin stuffs
    install(TARGETS appmenu-xfce DESTINATION ${CMAKE_INSTALL_LIBDIR}/xfce4/panel/plugins)
endif()
##########
# ValaPanel Part
##########
if(ENABLE_VALAPANEL)
    vala_precompile(VALA_C_VALAPANEL appmenu-valapanel
        valapanel-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        vala-panel
        libpeas-1.0
    OPTIONS
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --vapidir=${CMAKE_BINARY_DIR}/dbusmenu
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        --thread
        ${WNCK_DEFINE}
        ${NEW_DEFINE}
    )

    # Build library for plugins and application
    add_library (appmenu-valapanel MODULE
        ${VALA_C_VALAPANEL}
        ${RESOURCES}
    )
    set_target_properties(appmenu-valapanel PROPERTIES
        OUTPUT_NAME appmenu)
    target_link_libraries (appmenu-valapanel appmenu-core PEAS::PEAS PkgConfig::VALAPANEL)
    # Install plugin stuffs
    install(TARGETS appmenu-valapanel DESTINATION ${CMAKE_INSTALL_LIBDIR}/vala-panel/applets)
endif()
##########
# Budgie Panel Part
##########
if(ENABLE_BUDGIE)
    vala_precompile(VALA_C_BUDGIE appmenu-budgie
        budgie-plugin-appmenu.vala
    PACKAGES
        ${CORE_PACKAGES}
        vala-panel-appmenu
        ${WNCK_PACKAGES}
        budgie-1.0
        libpeas-1.0
    OPTIONS
        --vapidir=${CMAKE_SOURCE_DIR}/vapi
        --vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.50
        --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
        --thread
        ${WNCK_DEFINE}
    )

    # Build library for plugins and application
    add_library (appmenu-budgie MODULE
        ${VALA_C_BUDGIE}
        ${RESOURCES}
    )
    target_link_libraries (appmenu-budgie appmenu-core PEAS::PEAS PkgConfig::BUDGIE)
    # Install plugin stuffs
    install(TARGETS appmenu-budgie DESTINATION ${CMAKE_INSTALL_LIBDIR}/budgie-desktop/plugins/budgie-vala-panel-appmenu-plugin)
endif()
##########
# MATE Part
##########
if (ENABLE_MATE)
    vala_precompile(VALA_C_MATE appmenu-mate
	mate-plugin-appmenu.vala
    PACKAGES
	${CORE_PACKAGES}
	vala-panel-appmenu
	${WNCK_PACKAGES}
	libmatepanelapplet-4.0
    OPTIONS
	--vapidir=${CMAKE_SOURCE_DIR}/vapi
	--vapidir=${CMAKE_CURRENT_BINARY_DIR}
        --target-glib=2.50
	--gresources=${CMAKE_CURRENT_SOURCE_DIR}/libappmenu.gresource.xml
	--thread
	${WNCK_DEFINE}
    )
    add_executable (appmenu-mate
        ${VALA_C_MATE}
	${RESOURCES}
    )
    target_link_libraries (appmenu-mate appmenu-core PkgConfig::MATE)
    # Install plugin stuffs
    install(TARGETS appmenu-mate DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/mate-panel)
endif()
